'$INCLUDE: 'qbobject.bi'
'This program demonstrate how to use SetProperties, SetGridlineFocus, TextBox and Text.Cont command.
'You may point the cursor to an object or object controller and press F1 for parameters.

ON ERROR GOTO errors  'goto errors if error occured

'DIM SHARED txt1$, txt2$, txt3$, txt4$, txt5$                  'declare variables as SHARED when used with SUBS or FUNCTIONS
'DIM SHARED txt1id, txt2id, txt3id, txt4id, txt5id             'declare variables as SHARED when used with SUBS or FUNCTIONS

'draw sub window. No help button. control id must always 1.
win 200, 80, 600, 479, 0, "Text Box Example", 7, 1, 7, 1, 1
txt1$ = "Text box 1"

'draw textbox 1. This one uses the default properties.
textbox "_Textbox 1:", 1, 300, 140, 20, txt1id
setmsg "TXT 1", txt1id
putchar txt1$, txt1id

' set the colors and fieldeffect of textbox 2
setproperties txt2id, 1, 0, 3, 1, 1
'draw textbox 2
textbox "T_extbox 2:", 2, 300, 200, 10, txt2id

' set the colors and fieldeffect of textbox 3
setproperties txt3id, 6, 1, 2, 2, 0
'draw textbox 3
textbox "Te_xtbox 3:", 3, 300, 260, 25, txt3id

' set the colors and fieldeffect of textbox 4
setproperties txt4id, 5, 2, 4, 3, 8
'draw textbox 4
textbox "Text_box 4:", 4, 300, 320, 30, txt4id

' set the colors and fieldeffect of textbox 5
setproperties txt5id, 10, 13, 11, 4, 9
'draw textbox 5
textbox "Textb_ox 5:", 5, 300, 380, 5, txt5id

'separator line
line3 205, 420, 595, 420

'print our messages
font "F2 = Clear input     ESC = Exit", 280, 440, 1, 1, 7, 0

'focus to txt1id
setfocus txt1id
DO
  'control for txt1id. Maximum character of 100

  'setgridlinefocus applies only to text boxes, combo boxes, and spin boxes.
  
  setgridlinefocus 1
  text.cont txt1$, 100, txt1id
  IF focus = txt1id THEN LOCATE 1: PRINT text.col; txt1$; text.home; text.end
  IF key$ = "1" THEN text.disable txt1$, txt1id: setfocus txt2id
  IF key$ = "2" THEN text.enable txt1$, txt1id
 
  'control for txt2id. Maximum character of 80
  setgridlinefocus 0
  text.cont txt2$, 40, txt2id
  IF focus = txt2id THEN LOCATE 2: PRINT text.col; txt2$ + SPACE$(40 - LEN(txt2$))
 
  'control for txt3id. Maximum character of 60
  setgridlinefocus 1
  text.cont txt3$, 40, txt3id
  IF focus = txt3id THEN LOCATE 3: PRINT text.col; txt3$ + SPACE$(40 - LEN(txt3$))
 
  'control for txt4id. Maximum character of 40
  setgridlinefocus 0
  text.cont txt4$, 40, txt4id
  IF focus = txt4id THEN LOCATE 4: PRINT text.col; txt4$ + SPACE$(40 - LEN(txt4$))
 
  'control for txt5id. Maximum character of 5
  setgridlinefocus 1
  text.cont txt5$, 5, txt5id
  IF focus = txt5id THEN LOCATE 5: PRINT text.col; txt5$ + SPACE$(5 - LEN(txt5$))
 
  'Exit when ESC was pressed or window close button was clicked.
  IF click(2) OR key$ = CHR$(27) OR INKEY$ = CHR$(27) THEN EXIT DO
 
  'Click ,drag, and alt keys trapping. Must be the last line among all controls.
  getcontrol
 
LOOP
FREEXMS  'frees XMS handles. Extremely important
END

errors:
FREEXMS 'frees XMS handles. Extremely important
ERROR ERR 'show error

