DECLARE SUB savepro1 ()
DECLARE SUB savepro2 ()
'$INCLUDE: 'qbobject.bi'
'This program demonstrate how to use the UpdateList, ListUp, and ListDown command.
'You may point the cursor to an object or object controller and press F1 for parameters.
DIM SHARED list1.Lscroll, list1.Uscroll, list2.Lscroll, list2.Uscroll

ON ERROR GOTO errors  'goto errors if error occured

DIM list1(50) AS STRING
FOR a = 1 TO 25
  list1(a) = "List A" + STR$(a)
NEXT
DIM list2(50) AS STRING
FOR a = 1 TO 25
  list2(a) = "List B" + STR$(a)
NEXT

Win 100, 50, 500, 450, 0, "Update List Example", 7, 1, 7, 1, 1

ListBox 120, 100, 15, 15, list1(), list1id
ListBox 330, 100, 15, 15, list2(), list2id
Button ">", 280, 140, 320, 165, mov1rigid
Button "<", 280, 140 + 40, 320, 165 + 40, mov1lefid
Button ">>", 280, 140 + 100, 320, 165 + 100, movallrigid
Button "<<", 280, 140 + 100 + 40, 320, 165 + 100 + 40, movalllefid

Button "PgUp", 140, 410, 190, 440, pgup1id
Button "PgDw", 200, 410, 250, 440, pgdw1id

Button "PgUp", 350, 410, 400, 440, pgup2id
Button "PgDw", 410, 410, 460, 440, pgdw2id

'set our initial lists index

list1.Lscroll = 0
list1.Uscroll = 35

list2.Lscroll = 0
list2.Uscroll = 35

'focus to list1id
SetFocus list1id
DO
  IF list1.Lscroll = 0 THEN
    Button.Disable "Pgup", pgup1id
    IF focus = pgup1id THEN SetFocus list1id
  ELSE
    Button.Enable "Pgup", pgup1id
  END IF

  IF list1.Uscroll = 0 THEN
    Button.Disable "Pgdw", pgdw1id
    IF focus = pgdw1id THEN SetFocus list1id
  ELSE
    Button.Enable "Pgdw", pgdw1id
  END IF

  IF list2.Lscroll = 0 THEN
    Button.Disable "Pgup", pgup2id
    IF focus = pgup2id THEN SetFocus list2id
  ELSE
    Button.Enable "Pgup", pgup2id
  END IF

  IF list2.Uscroll = 0 THEN
    Button.Disable "Pgdw", pgdw2id
    IF focus = pgdw2id THEN SetFocus list2id
  ELSE
    Button.Enable "Pgdw", pgdw2id
  END IF

 
  'control for lst1id
  lst1$ = List.Cont(list1(), 15, 1, list1id)
  IF focus = list1id THEN
    savepro1
  END IF
 
  'control for lst2id
 
  lst2$ = List.Cont(list2(), 15, 1, list2id)
  IF focus = list2id THEN
    savepro2
  END IF
 
  'button controls
 
  IF Button.Cont(pgup1id) THEN
    ListUp 15, list1(), list1id
    savepro1
  END IF
  IF Button.Cont(pgdw1id) THEN
    ListDown 15, list1(), list1id
    savepro1
  END IF
 
  IF Button.Cont(pgup2id) THEN
    ListUp 15, list2(), list2id
    savepro2
  END IF
  IF Button.Cont(pgdw2id) THEN
    ListDown 15, list2(), list2id
    savepro2
  END IF
  mov1lef = Button.Cont(mov1lefid)
  mov1rig = Button.Cont(mov1rigid)
  movalllef = Button.Cont(movalllefid)
  movallrig = Button.Cont(movallrigid)
 
  'set focus to list1id/list2id when a list was choosed
  IF lst1$ <> "" THEN SetFocus list1id
  IF lst2$ <> "" THEN SetFocus list2id
 
  IF (mov1rig AND list1(list.index(list1id)) <> "") OR (key$ = rig$ AND focus = list1id) THEN
    
    tmp$ = list1(list.index(list1id))
    FOR a = list.index(list1id) TO 49
      list1(a) = list1(a + 1)
    NEXT
    list1(a) = ""
   
    FOR a = 50 TO list.index(list2id) STEP -1
      list2(a) = list2(a - 1)
    NEXT
    list2(list.index(list2id)) = tmp$
   
    Button.Enable "<", mov1lefid
    Button.Enable "<<", movalllefid
   
    'update all list box
    UpdateList list1(), 0, list1id
    savepro1
   
    UpdateList list2(), 0, list2id
    savepro2
    IF Disabled(list2id) THEN List.Enable list2(), list2id
   
    SetFocus list1id
    IF list1(1) = "" THEN
      List.Disable list1(), list1id: SetFocus list2id
      Button.Disable ">", mov1rigid
      Button.Disable ">>", movallrigid
    END IF
  END IF
 
  IF (mov1lef AND list2(list.index(list2id)) <> "") OR (key$ = lef$ AND focus = list2id) THEN
   
    tmp$ = list2(list.index(list2id))
    FOR a = list.index(list2id) TO 49
      list2(a) = list2(a + 1)
    NEXT
    list2(a) = ""
  
    FOR a = 50 TO list.index(list1id) STEP -1
      list1(a) = list1(a - 1)
    NEXT
    list1(list.index(list1id)) = tmp$
   
    Button.Enable ">", mov1rigid
    Button.Enable ">>", movallrigid
   
    'update all list box
    UpdateList list1(), 0, list1id
    savepro1
    IF Disabled(list1id) THEN List.Enable list1(), list1id
   
    UpdateList list2(), 0, list2id
    savepro2
   
    SetFocus list2id
    IF list2(1) = "" THEN
      List.Disable list2(), list2id: SetFocus list1id
      Button.Disable "<", mov1lefid
      Button.Disable "<<", movalllefid
    END IF
  END IF
 
  IF movallrig AND list1(1) <> "" THEN 'move List Box 1 content TO List Box 2
    FOR a = 50 TO 1 STEP -1
      IF list1(a) <> "" THEN EXIT FOR
    NEXT
    lasta = a
   
    FOR a = 50 TO lasta + 1 STEP -1
      list2(a) = list2(a - lasta)
    NEXT
   
    FOR a = 1 TO lasta
      list2(a) = list1(a)
      list1(a) = ""
    NEXT
   
    Button.Enable "<<", movalllefid
    Button.Enable "<", mov1lefid
    Button.Disable ">", mov1rigid
    Button.Disable ">>", movallrigid
   
    'update all list box
    UpdateList list1(), 0, list1id
    savepro1
    List.Disable list1(), list1id
   
    IF Disabled(list2id) THEN List.Enable list2(), list2id
    UpdateList list2(), 0, list2id
    savepro2
   
    SetFocus list2id
  END IF

  IF movalllef AND list2(1) <> "" THEN 'move List Box 2 content TO List Box 1
    FOR a = 50 TO 1 STEP -1
      IF list2(a) <> "" THEN EXIT FOR
    NEXT
    lasta = a
  
    FOR a = 50 TO lasta + 1 STEP -1
      list1(a) = list1(a - lasta)
    NEXT
  
    FOR a = 1 TO lasta
      list1(a) = list2(a)
      list2(a) = ""
    NEXT
 
    Button.Disable "<<", movalllefid
    Button.Disable "<", mov1lefid
    Button.Enable ">", mov1rigid
    Button.Enable ">>", movallrigid
    'update all list box
    IF Disabled(list1id) THEN List.Enable list1(), list1id
    UpdateList list1(), 0, list1id
    savepro1
   
    UpdateList list2(), 0, list2id
    savepro2
    List.Disable list2(), list2id
   
    SetFocus list1id
  END IF
 
 
  IF key$ = rig$ AND focus = list2id THEN SetFocus list1id
  IF key$ = lef$ AND focus = list1id THEN SetFocus list2id
 
  'Exit when ESC was pressed or window close button was clicked.
  IF Click(2) OR key$ = CHR$(27) OR INKEY$ = CHR$(27) THEN EXIT DO

  'Click ,drag, and alt keys trapping. Must be the last line among all controls.
  GetControl

LOOP
FREEXMS  'frees XMS handles. Extremely important
END

errors:
FREEXMS 'frees XMS handles. Extremely important
PRINT list.index(list1id)
SLEEP
ERROR ERR 'show error

REM $DYNAMIC
SUB savepro1
    list1.Lscroll = list.Lscroll
    list1.Uscroll = list.Uscroll
END SUB

SUB savepro2
    list2.Lscroll = list.Lscroll
    list2.Uscroll = list.Uscroll
END SUB

